'use strict';

module.exports = function({ hasJsxRuntime }) {
  return {
    presets: [
      require('@babel/preset-modules'),
      [
        require('@babel/preset-react').default,
        { runtime: hasJsxRuntime ? 'automatic' : 'classic' }
      ],
      require('@babel/preset-typescript').default
    ],
    plugins: [
      require('@babel/plugin-proposal-nullish-coalescing-operator').default,
      require('@babel/plugin-proposal-optional-chaining').default,
      require('@babel/plugin-proposal-class-properties').default,
      require('@babel/plugin-proposal-numeric-separator').default,
      require('@babel/plugin-syntax-dynamic-import').default
    ]
  };
};
