'use strict';

const paths = require('./paths');
const isProduction = process.env.NODE_ENV === 'production';
const fs = require('fs');
const path = require('path');

const webpackConfigFilePath = path.resolve(paths.appPath, 'webpack.config.js');
const webpackConfigFilePathProd = path.resolve(paths.appPath, 'webpack.config.prod.js');
let configToMerge;
if (isProduction && fs.existsSync(webpackConfigFilePathProd)) {
  configToMerge = webpackConfigFilePathProd;
} else if (fs.existsSync(webpackConfigFilePath)) {
  configToMerge = webpackConfigFilePath;
}

exports.mergeWebpackConfig = (config) => {
  try {
    const packageJson = require(paths.appPackageJson).webpackConfig || {};
    ['externals'].forEach(d => {
      if (packageJson[d]) {
        config[d] = packageJson[d];
      }
    });
    if (configToMerge) {
      config = require(configToMerge)(config);
    }
    // eslint-disable-next-line no-empty
  } catch (e) { }
  return config;
}
