"use strict";

const prod = require("./webpack.config.prod");
module.exports = ({ useModern, useHash } = {}) => {
  const config = prod({ useModern, useHash });
  // 使用umd导出
  config.output.libraryTarget = "umd";
  // 禁用pwa
  config.plugins = config.plugins.filter(x => {
    if (x.constructor && x.constructor.name === "GenerateSW") {
      return false;
    } else {
      return true;
    }
  });
  // 禁止拆分为chunk
  config.optimization.splitChunks = {
    cacheGroups: {
      default: false
    }
  }
  config.optimization.runtimeChunk = false;

  return config;
};
