'use strict';
let createStyledComponentsTransformer;
try {
  createStyledComponentsTransformer = require('typescript-plugin-styled-components')
    .default;
} catch (e) {
  if (e && e.code === 'MODULE_NOT_FOUND') {
    console.warn(
      'please run `npm install -D typescript-plugin-styled-components'
    );
  }
}

// create getCustomTransformer function
const getCustomTransformers = () => ({
  before: [
    createStyledComponentsTransformer && createStyledComponentsTransformer({ ssr: true })
  ].filter(Boolean)
});

// export getCustomTransformers
module.exports = getCustomTransformers;
