/* eslint-disable no-unused-vars */
'use strict';

const fs = require('fs-extra');
const less = require('less')

const glob = require('glob');


// 编译类
class compilerObject {
    constructor(file) {
        this.filepath = file
        this.outpath = ''
        this.compileResult = null
    }
    init(intputPath,targetPath) {
        this.outpath = this.filepath.replace(intputPath, targetPath).replace('.less', '.css')
    }
    // 读取编译
    async compile() {
        let file = await fs.readFile(this.filepath, 'utf8')   
        this.compileResult = await less.render(file)
    }
    // 输出
    async outPut() {
        if(this.compileResult.css) {
            await fs.writeFile(this.outpath, this.compileResult.css)
        }
    }
    async render() {
        await this.compile()
        await this.outPut()
    }
}
// 工厂
function factoryInitedCompiler(files, intputPath,targetPath) {
    return files.map((file) => {
        let result = new compilerObject(file)
        result.init(intputPath, targetPath)
        return result.render()
    }) 
}


async function compileLess(
    intputPath,
    targetpath, 
) {
    const files = await glob.sync(intputPath + '/*.less');

    if(files.length === 0) return

    let compilersList = factoryInitedCompiler(files, intputPath, targetpath)

    await Promise.all(compilersList)
}

exports.default = compileLess
