'use strict';

const cp = require('child_process');

module.exports.default = function compileTypeScript(cwd, useESModule) {
  return new Promise(r => {
    const worker = cp.spawn(
      'npx',
      `tsc -p tsconfig.json --target ${
        useESModule ? 'es2019' : 'es5'
        } --module ${useESModule ? 'esnext' : 'commonjs'} --outDir ${
        useESModule ? 'es' : 'lib'
        } -d --newLine LF`.split(' '),
      {
        cwd,
        stdio: 'inherit'
      }
    );
    worker.once('close', () => {
      r();
    });
  });
};
