'use strict';
const paths = require('../../config/paths');
const path = require('path');
const program = require('commander');
const pkgCfg = require(path.resolve(__dirname, '..', '..', 'package.json'));
const cwd = process.env.BRS_PROJECT_ROOT || process.cwd();

program
  .version(pkgCfg.version)
  .option('--ssr', 'build or dev ssr bundle')
  .option('--csr', 'build or dev csr bundle')
  .option('--library', 'build a umd library')
  // .option('--snap', 'run react-snap to generate prerender html assets')
  .option(
    '--modern',
    'build for modern browser and use script[type=module] to import'
  )
  // TODO: monorepo 适配
  // .option('--monorepo <workspace>', 'whether use monorepo', () => {

  // })
  .option('--no_hash', 'whether not attach hash in filename', false)
  .option('--profile', 'Variable used for enabling profiling in Production')
  .option(
    '-o, --out [path]',
    'config the project output root directory',
    v => {
      if (v) {
        return path.resolve(cwd, v);
      } else {
        return paths.appBuild;
      }
    },
    paths.appBuild
  )
  .option('--port [port]', 'inspect port for [byted-react-scripts test]', v => {
    if (Number(v) > 0 && !isNaN(Number(v))) {
      return Number(v);
    }
    return undefined;
  })
  .option('--loader_time', 'show loader cost time', false)
  .parse(process.argv);

if (program.csr === undefined && program.ssr === undefined) {
  program.csr = true;
  program.ssr = true;
}

module.exports = program;
