'use strict';

const path = require('path');
const cpFile = require('cp-file');
const glob = require('glob');

exports.default = (sourceGlob, targetRoot, cwd = process.env.BRS_PROJECT_ROOT || process.cwd()) => {
  targetRoot = path.resolve(cwd, targetRoot);
  return new Promise((r, j) => {
    glob(sourceGlob, { cwd, dot: true, nodir: true }, (_, matches) => {
      r(
        Promise.all(
          matches.map(name => {
            const source = path.resolve(cwd, name);
            const relative = path.relative(cwd, path.resolve(cwd, name));
            const dist = path.resolve(targetRoot, relative);

            return cpFile(source, dist).then(() => {
              console.log(`${name} => ${dist}`);
            });
          })
        )
      );
    });
  });
};
