'use strict';

const { exec } = require('child_process');
const { promisify } = require('util');
const execAsync = promisify(exec);

let username = null
async function getUsername() {
  if (!username) {
    try {
      username = (await execAsync('git config user.name')).stdout.trim();
      return username;
    } catch (e) {
      return null
    }
  } else {
    return username;
  }
}
exports.getUsername = getUsername;
